<?php

/*
 * HostBill payline gateway module
 * @see http://AriaCoders.ir ::MortezaSaheb :: 09141776345
 *
 * 2013 HostBill -  Complete Client Management, Support and Billing Software
 * http://www.AriaCoders.com
 */

class payline extends PaymentModule {

    protected $modname = 'درگاه پرداخت ePayBank';

    protected $description = 'این ماژول توسط سایت ePayBank نوشته شده است';

    protected $supportedCurrencies = array();


    protected $configuration = array(
        'api' => array(
            'value' => '',
            'type' => 'input',
            'description' => 'لطفا کلید MerchentId خود را وارد کنید'
        ),
	'apipass' => array(
            'value' => '',
            'type' => 'input',
            'description' => 'لطفا کلید MerchentPass خود را وارد کنید'
        ),
		'success_message' => array(
            'value' => 'پرداخت با موفقیت انجام شد',
            'type' => 'input',
            'description' => 'پیام موفقیت'
        ),
    );

    public function drawForm() {
        function send($merchentid,$merchentpass,$callback,$amount,$bank,$orderid){
//==========================================================================================
require_once "./lib/nusoap.php";
$client=new nusoap_client("http://epaybank.ir/secure_gateway/index.php");
$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
$result=$client->call("requestpayment",array($merchentid,$merchentpass,$callback,$amount,$bank,$orderid));
$client->soap_defencoding = 'UTF-8';
if($client->fault){
	echo "<h2>Fault</h2><pre>";
	print_r($result);
	echo "</pre>";
}
else
{
$error=$client->getError();
	if($error)
	{
		return "<h2>Error</h2><pre>".$error."</pre>";
	}
	else
	{
		
		return $result;
		
	}
}
//==========================================================================================
				
				}
				
				

			
			$api = $this->configuration['api']['value'] ;
			$apipass = $this->configuration['apipass']['value'] ;
			$amount = $this->amount;
			$redirect = $this->callback_url ;
			$_SESSION['invoiceid']=$this->invoice_id;
			$_SESSION['amount']= $amount;
			
			$result = send($api,$apipass,$redirect,$amount,"parsian",$_SESSION['invoiceid']);
				if(filter_var($result, FILTER_VALIDATE_URL)){
					//$_SESSION['id_get']= $result;
				$go = $result;
				header("Location: $go");
				}
				switch($result){
					case '-1':
					echo 'کد پذیرندگی یا رمز عبور تعریفی در سیستم وجود ندارد';
					break;
					case '-2':
					echo 'صفحه برگشت تعریف نشده است یا ادرس اینترنتی نیست';
					break;
					case '-3':
					echo 'کد پذیرندگی یا رمز عبور عددی نیست';
					break;
					case '-4':
					echo ' آدرس آی پی سرور شما درست وارد نشده است لطفا از پنل کاربری خود اپدیت نمایید';
					break;
					case '-5':
					echo ' مقدار وجه قیمت عددی نیست';
					break;
					case '-6':
					echo ' نام بانک ارسالی معتبر نیست';
					break;
					case '-7':
					echo ' مقدار وجه نباید کمتر از ۵۰۰ تومان باشد';
					break;
					case '-8':
					echo 'شماره سفارش عددی نیست';
					break;
					case '-9':
					echo 'شماره خرید تکراری است';
					break;
					case '-11':
					echo 'درگاه شما غیرفعال می باشد';
					break;
				}
    }
	

    function callback() {  
	
			function get($merchentid,$merchentpass,$amount,$rs,$bank){
//===============================================================
require_once "./lib/nusoap.php";
$client=new nusoap_client("http://epaybank.ir/secure_gateway/index.php");
$client->soap_defencoding = 'UTF-8';

$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
$result=$client->call("verifypeyment",array($merchentid,$merchentpass,$amount,$rs,$bank));
$client->soap_defencoding = 'UTF-8';

if($client->fault){
	echo "<h2>Fault</h2><pre>";
	print_r($result);
	echo "</pre>";
}
else
{
$error=$client->getError();
	if($error){
		return "<h2>Error</h2><pre>".$error."</pre>";
	}
	else
	{
		//echo "<h2>Result</h2><pre>";
		return $result;
		//echo "</pre>";
	}
}
//===============================================================
				
				}     

				$api = $this->configuration['api']['value'];
				$apipass = $this->configuration['apipass']['value'];
				$amount = $_SESSION['amount'];
				$rs = $_GET['rs'];
				$result = get($api,$apipass,$amount,$rs,"parsian");


        if ( $result == '-33' ) {
            //2. log incoming payment
            $this->logActivity(array(
                'result' => 'Successfull',
                'output' => $_GET
            ));

            //3. add transaction to invoice
            $invoice_id = $_SESSION['invoiceid'];
            $amount = $_SESSION['amount'];
            $fee = 0;
            $transaction_id = get($trans_id);
            
            $this->addTransaction(array(
                'in' => $amount,
                'invoice_id' => $invoice_id,
                'fee' => $fee,
                'transaction_id' => $transaction_id
		      
            ));
			$this->addInfo($this->configuration['success_message']['value']);
            Utilities::redirect('?cmd=clientarea');
       
            
        } else {
             $this->logActivity(array(
                'result' => 'Failed',
                'output' => $_POST
				
            ));
			Utilities::redirect('?cmd=clientarea');
			
			
        }
    }

}
